/*
 * Blockstream Esplora HTTP API
 *
 * JSON over RESTful HTTP. Amounts are always represented in satoshis.
 *
 * The version of the OpenAPI document: 1.0.1
 * 
 * Generated by: https://openapi-generator.tech
 */




#[derive(Clone, Debug, PartialEq, Serialize, Deserialize)]
pub struct InlineResponseDefault {
    /// A list of transaction hashes the current hash is paired with, deepest pairing first.
    #[serde(rename = "merkle")]
    pub merkle: Vec<String>,
    /// The height of the block the transaction was confirmed in.
    #[serde(rename = "block_height")]
    pub block_height: f32,
    /// The 0-based index of the position of the transaction in the ordered list of transactions in the block.
    #[serde(rename = "pos")]
    pub pos: f32,
}

impl InlineResponseDefault {
    pub fn new(merkle: Vec<String>, block_height: f32, pos: f32) -> InlineResponseDefault {
        InlineResponseDefault {
            merkle,
            block_height,
            pos,
        }
    }
}


